## iwrite-3.1.1.0.tar.gz

=== Makefile ===
# vim:noexpandtab:softtabstop=2:tabstop=2:shiftwidth=2:nowrap
# 
# Copyright (c) 2015-2016, iwrite authors
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

.SILENT:

UNAME:= $(shell uname)
BITS:= $(shell uname -m)

SUFFIX= so

ifeq ($(UNAME), MINGW64_NT-10.0)

SUFFIX= dll

endif

ifndef prefix
	ifeq ($(UNAME), OpenBSD)
		prefix=/usr/local
	else ifeq ($(UNAME), FreeBSD)
		prefix=/usr/local
	else ifeq ($(UNAME), NetBSD)
		prefix=/usr/pkg
	else ifeq ($(UNAME), MINGW64_NT-10.0)
		prefix=/mingw64
	else
		prefix=/usr
	endif
endif

ifndef BINDIR
	BINDIR=${prefix}/bin
endif

ifndef LIBDIR
	LIBDIR=${prefix}/lib

	ifeq ($(UNAME), Linux)
		ifeq ($(BITS), x86_64)
			LIBDIR=${prefix}/lib64
		endif
	endif
endif

ifndef DATADIR
	DATADIR=${prefix}/share/iwrite
endif

UIDIR=${DATADIR}/ui

ifndef DOCDIR
	DOCDIR=${prefix}/share/doc/iwrite
endif

.PHONY: all
all: docs iwrite drivers

.PHONY: docs
docs: doc/iwrite.pdf
	@echo finished documentation

doc/iwrite.pdf:
	@cd doc && ${MAKE}

.PHONY: iwrite
iwrite: src/iwrite
	@echo finished iwrite

src/iwrite: 
	@cd src && ${MAKE}

.PHONY: drivers
ifeq ($(UNAME), Linux)
drivers:\
	drivers/postgres/libiwsql_pq.${SUFFIX} \
	drivers/mariadb/libiwsql_mariadb.${SUFFIX} \
	drivers/sqlite3/libiwsql_sqlite3.${SUFFIX} \
	drivers/oracle/libiwsql_oracle.${SUFFIX}
else
drivers:\
	drivers/postgres/libiwsql_pq.${SUFFIX} \
	drivers/mariadb/libiwsql_mariadb.${SUFFIX} \
	drivers/sqlite3/libiwsql_sqlite3.${SUFFIX}
endif
	@echo finished database drivers

drivers/postgres/libiwsql_pq.${SUFFIX}: 
	@cd drivers && ${MAKE} postgres

drivers/mariadb/libiwsql_mariadb.${SUFFIX}:
	@cd drivers && ${MAKE} mariadb

drivers/sqlite3/libiwsql_sqlite3.${SUFFIX}:
	@cd drivers && ${MAKE} sqlite3

drivers/oracle/libiwsql_oracle.${SUFFIX}:
	@cd drivers && ${MAKE} oracle

.PHONY: clean
clean:
	@echo making clean
	cd drivers && ${MAKE} clean
	cd src/decNumber && ${MAKE} clean
	cd src/icu && ${MAKE} clean
	cd src/ruler && ${MAKE} clean
	cd src/geometry && ${MAKE} clean
	cd src/zint && ${MAKE} clean
	cd src && ${MAKE} clean

.PHONY: install
install:
	@echo installing iwrite
	test -d ${DESTDIR}${BINDIR} || mkdir -p ${DESTDIR}${BINDIR}
	test -d ${DESTDIR}${LIBDIR} || mkdir -p ${DESTDIR}${LIBDIR}
	test -d ${DESTDIR}${DOCDIR} || mkdir -p ${DESTDIR}${DOCDIR}
	test -d ${DESTDIR}${DATADIR} || mkdir -p ${DESTDIR}${DATADIR}
	test -d ${DESTDIR}${UIDIR} || mkdir -p ${DESTDIR}${UIDIR}
	install -s -m 0655 src/iwrite ${DESTDIR}${BINDIR}/iwrite
	install -s -m 0755 drivers/postgres/libiwsql_pq.${SUFFIX} ${DESTDIR}${LIBDIR}/libiwsql_pq.${SUFFIX} 
	install -s -m 0755 drivers/mariadb/libiwsql_mariadb.${SUFFIX} ${DESTDIR}${LIBDIR}/libiwsql_mariadb.${SUFFIX} 
	install -s -m 0755 drivers/sqlite3/libiwsql_sqlite3.${SUFFIX} ${DESTDIR}${LIBDIR}/libiwsql_sqlite3.${SUFFIX} 
ifeq ($(UNAME), Linux)
	install -s -m 0755 drivers/oracle/libiwsql_oracle.${SUFFIX} ${DESTDIR}${LIBDIR}/libiwsql_oracle.${SUFFIX} 
endif
	install -m 0444 README ${DESTDIR}${DOCDIR}/README
	install -m 0444 COPYING ${DESTDIR}${DOCDIR}/COPYING
	install -m 0444 doc/iwrite.pdf ${DESTDIR}${DOCDIR}/iwrite.pdf
	install -m 0644 src/break.glade ${DESTDIR}${UIDIR}/break.glade
	install -m 0644 src/circle.glade ${DESTDIR}${UIDIR}/circle.glade
	install -m 0644 src/database.glade ${DESTDIR}${UIDIR}/database.glade
	install -m 0644 src/date.glade ${DESTDIR}${UIDIR}/date.glade
	install -m 0644 src/export.glade ${DESTDIR}${UIDIR}/export.glade
	install -m 0644 src/export_page_setup.glade ${DESTDIR}${UIDIR}/export_page_setup.glade
	install -m 0644 src/fbarcode.glade ${DESTDIR}${UIDIR}/fbarcode.glade
	install -m 0644 src/field.glade ${DESTDIR}${UIDIR}/field.glade
	install -m 0644 src/fimage.glade ${DESTDIR}${UIDIR}/fimage.glade
	install -m 0644 src/fnumber.glade ${DESTDIR}${UIDIR}/fnumber.glade
	install -m 0644 src/frame.glade ${DESTDIR}${UIDIR}/frame.glade
	install -m 0644 src/fsum.glade ${DESTDIR}${UIDIR}/fsum.glade
	install -m 0644 src/ftext.glade ${DESTDIR}${UIDIR}/ftext.glade
	install -m 0644 src/image.glade ${DESTDIR}${UIDIR}/image.glade
	install -m 0644 src/label_page_setup.glade ${DESTDIR}${UIDIR}/label_page_setup.glade
	install -m 0644 src/layout_page_setup.glade ${DESTDIR}${UIDIR}/layout_page_setup.glade
	install -m 0644 src/line.glade ${DESTDIR}${UIDIR}/line.glade
	install -m 0644 src/mainwindow.glade ${DESTDIR}${UIDIR}/mainwindow.glade
	install -m 0644 src/page_number.glade ${DESTDIR}${UIDIR}/page_number.glade
	install -m 0644 src/query.glade ${DESTDIR}${UIDIR}/query.glade
	install -m 0644 src/README.glade ${DESTDIR}${UIDIR}/README
	install -m 0644 src/report.glade ${DESTDIR}${UIDIR}/report.glade
	install -m 0644 src/runreport.glade ${DESTDIR}${UIDIR}/runreport.glade
	install -m 0644 src/scrollwin.glade ${DESTDIR}${UIDIR}/scrollwin.glade
	install -m 0644 src/text.glade ${DESTDIR}${UIDIR}/text.glade

.PHONY: uninstall
uninstall:
	@echo uninstalling iwrite
	@rm -f ${DESTDIR}${BINDIR}/iwrite
	@rm -f ${DESTDIR}${LIBDIR}/libiwsql_pq.${SUFFIX} 
	@rm -f ${DESTDIR}${LIBDIR}/libiwsql_mariadb.${SUFFIX} 
	@rm -f ${DESTDIR}${LIBDIR}/libiwsql_sqlite3.${SUFFIX} 
	@rm -f ${DESTDIR}${LIBDIR}/libiwsql_oracle.${SUFFIX} 
	@rm -rf ${DESTDIR}${DOCDIR}
	@rm -rf ${DESTDIR}${DATADIR}
