=== packaging/debian/changelog ===
iwrite (3.1.1.0-1) unstable; urgency=low

  * Add Sub-report

 -- Mark Olesen <markjolesen@gmail.com>  Wed, 20 Jul 2016 21:29:38 -0700

iwrite (3.0.1.0-1) unstable; urgency=low

  * Add edit/undo
  * Bug fixes

 -- Mark Olesen <markjolesen@gmail.com>  Sun, 05 Jun 2016 06:47:46 -0700

iwrite (2.0.1.0-1) unstable; urgency=low

  * Use XML instead of BSON

 -- Mark Olesen <markjolesen@gmail.com>  Fri, 12 Feb 2016 01:10:17 -0700

iwrite (1.0.1.4-1) unstable; urgency=low

  * Initial beta release.

 -- Mark Olesen <markjolesen@gmail.com>  Tue, 12 Jan 2016 01:22:49 -0700
