=== packaging/abs/PKGBUILD ===
pkgname=iwrite
pkgver=3.1.1.0
pkgrel=1
pkgdesc='SQL report writer'
arch=('i686' 'x86_64')
url='http://www.nongnu.org/iwrite/'
license=('BSD')
depends=('icu' 'gtk3')
# makedepends need to add postgres mariadb or mysql client + oracle client libs
source=(
"http://download.savannah.gnu.org/releases/iwrite/$pkgname-$pkgver.tar.gz"
"http://download.savannah.gnu.org/releases/iwrite/$pkgname-$pkgver.tar.gz.sig"
)

md5sums=('SKIP' 'SKIP')


build() {
  cd "$srcdir/$pkgname-$pkgver"
  make
}

package() {
  cd "$srcdir/$pkgname-$pkgver"
  make DESTDIR="$pkgdir" LIBDIR=/usr/lib install
}
